variables:
  GROUP: "mopsa"
  GIT_REPO: "gitlab.com/${GROUP}/mopsa-analyzer.git"
  BRANCH: "main"
  FORCE_BASELINE_UPDATE: "false"
  FF_USE_FASTZIP: "true"
  DOCKER_DRIVER: overlay2
  GIT_STRATEGY: fetch

image: mopsa/mopsa-build:latest

stages:
- Build
- Benchmarks

mopsa:
  stage: Build
  script:
  - echo $GIT_REPO $BRANCH
  - git clone -b $BRANCH https://gitlab-ci-token:${CI_JOB_TOKEN}@$GIT_REPO
  - cd mopsa-analyzer
  - eval `opam config env`
  - ./configure
  - make -j
  artifacts:
    paths:
    - ./mopsa-analyzer/bin/
    - ./mopsa-analyzer/parsers/c/_build/wrapper.native
    - ./mopsa-analyzer/analyzer/_build/mopsa.native
    - ./mopsa-analyzer/_build/default/parsers/c/bin/build_wrapper.exe
    - ./mopsa-analyzer/_build/default/analyzer/mopsa.exe
    - ./mopsa-analyzer/share
    - ./mopsa-analyzer/tools/mopsa-diff/mopsa-diff
    - ./mopsa-analyzer/tools/get-artifact.py
    expire_in: 4h

bitarray:
  stage: Benchmarks
  dependencies: [mopsa]
  script:
  - eval `opam config env`
  - export PATH=$(realpath ./mopsa-analyzer/bin/):$PATH
  - OUTPUT_DIR=results MOPSA_OPTIONS="-format=json -tail-markers=0" make
  - ./mopsa-analyzer/tools/get-artifact.py bitarray-analysis "${CI_JOB_NAME}" --token "${API_TOKEN}" --group ${GROUP}%2Fbenchmarks%2Fcpython-benchmarks || true
  - |
    if [ -f artifacts.zip ]; then
      unzip artifacts.zip -d oracle;
      $FORCE_BASELINE_UPDATE || ./mopsa-analyzer/tools/mopsa-diff/mopsa-diff --ignore-time oracle/results/ results/;
    fi
  artifacts:
    paths:
      - results/test_bitarray*.json
    when: always
